#define reg_init
global.dll_reg_set_root = external_define("regedit.dll","regSetRoot",dll_stdcall,ty_real,1,ty_real);
global.dll_reg_get_type = external_define("regedit.dll","regGetType",dll_stdcall,ty_real,2,ty_string,ty_string);
global.dll_reg_exists_value = external_define("regedit.dll","regExistsValue",dll_stdcall,ty_real,2,ty_string,ty_string);
global.dll_reg_exists_key = external_define("regedit.dll","regExistsKey",dll_stdcall,ty_real,1,ty_string);
global.dll_reg_read_string = external_define("regedit.dll","regReadString",dll_stdcall,ty_string,3,ty_string,ty_string,ty_real);
global.dll_reg_read_binary = external_define("regedit.dll","regReadBinary",dll_stdcall,ty_string,2,ty_string,ty_string);
global.dll_reg_read_int = external_define("regedit.dll","regReadInt",dll_stdcall,ty_real,2,ty_string,ty_string);
global.dll_reg_write_string = external_define("regedit.dll","regWriteString",dll_stdcall,ty_real,4,ty_string,ty_string,ty_string,ty_real);
global.dll_reg_write_binary = external_define("regedit.dll","regWriteBinary",dll_stdcall,ty_real,3,ty_string,ty_string,ty_string);
global.dll_reg_write_int = external_define("regedit.dll","regWriteInt",dll_stdcall,ty_real,4,ty_real,ty_string,ty_real,ty_real);
global.dll_reg_delete_value = external_define("regedit.dll","regDeleteValue",dll_stdcall,ty_real,2,ty_string,ty_string);
global.dll_reg_delete_key = external_define("regedit.dll","regDeleteKey",dll_stdcall,ty_real,1,ty_string);
global.dll_reg_create_key = external_define("regedit.dll","regCreateKey",dll_stdcall,ty_real,1,ty_string);

#define reg_set_root
// argument0 = id of the root key:
//   0 = HKEY_CLASSES_ROOT
//   1 = HKEY_CURRENT_USER
//   2 = HKEY_LOCAL_MACHINE
//   3 = HKEY_USERS
//   4 = HKEY_CURRENT_CONFIG
// default HKEY_LOCAL_MACHINE is set as root key

return external_call(global.dll_reg_set_root,argument0);
#define reg_get_type
// returns the type of the value in the registry
//
// argument0 = key
// argument1 = value
//
// returns a code for the types:
//   -1 = other than the following
//   0 = REG_SZ
//   1 = REG_EXPAND_SZ
//   2 = REG_MULTI_SZ
//   3 = REG_BINARY
//   4 = REG_DWORD
//   5 = REG_QWORD

return external_call(global.dll_reg_get_type,argument0,argument1);
#define reg_exists_value
// returns whether the key and value exists
//
// argument0 = key
// argument1 = value

return external_call(global.dll_reg_exists_value,argument0,argument1);
#define reg_exists_key
// returns whether the key exists
//
// argument0 = key

return external_call(global.dll_reg_exists_key,argument0);
#define reg_create_key
// creates a new key and returns whether successful
//
// argument0 = key

external_call(global.dll_reg_create_key,argument0);
#define reg_delete_value
// deletes a value from the registry and returns whether successful
//
// argument0 = key
// argument1 = name of value

external_call(global.dll_reg_delete_value,argument0,argument1);
#define reg_delete_key
// deletes a key from the registry and returns whether successful
//
// argument0 = key

external_call(global.dll_reg_delete_key,argument0);
#define reg_read_string
// reading a value of one of the following types:
//   REG_SZ
//   REG_EXPAND_SZ
//   REG_MULTI_SZ
//
// argument0 = key
// argument1 = name of value
// argument2 = is only needed, if the value is of type REG_MULTI_SZ
//             and is the number of the string of the sequence to return
//             (0 for the first one)
//
// returns contents of the value

return external_call(global.dll_reg_read_string,argument0,argument1,argument2);
#define reg_read_binary
// returns a value of type REG_BINARY in hexadecimal representation
// e.g. "303132333435" for "012345"
//
// argument0 = key
// argument1 = name of value

return external_call(global.dll_reg_read_binary,argument0,argument1);
#define reg_read_int
// reading a value of one of the following types:
//   REG_DWORD    (32-bit number)
//   REG_QWORD    (64-bit number)
//
// argument0 = key
// argument1 = name of value
//
// returns contents of the value

return external_call(global.dll_reg_read_int,argument0,argument1);
#define reg_write_string
// writing a value of one of the string types (see below)
//
// argument0 = key
// argument1 = name of value
// argument2 = value
// argument3 = type of value:
//   0 = REG_SZ
//   1 = REG_EXPAND_SZ
//   2 = REG_MULTI_SZ

external_call(global.dll_reg_write_string,argument0,argument1,argument2,argument3);
#define reg_write_binary
// writes data of type REG_BINARY to the registry and returns whether successful
// the data has to be hexadecimal representation
// e.g. "303132333435" for "012345"
//
// argument0 = key
// argument1 = name of value
// argument2 = data

return external_call(global.dll_reg_write_binary,argument0,argument1,argument2);
#define reg_write_int
// writing a value of one of the integer types (see below)
//
// argument0 = key
// argument1 = name of value
// argument2 = value
// argument3 = type of value:
//   4 = REG_DWORD
//   5 = REG_QWORD

external_call(global.dll_reg_write_int,argument0,argument1,argument2,argument3);
